# Find Graphviz (http://www.graphviz.org)
# Defines
# GRAPHVIZ_INCLUDE_DIRS
# GRAPHVIZ_LIBRARIES
# GRAPHVIZ_FOUND

FIND_PATH(GRAPHVIZ_INCLUDE_DIR NAMES graphviz/graph.h)

FIND_LIBRARY(GRAPHVIZ_gvc_LIBRARY NAMES gvc )
FIND_LIBRARY(GRAPHVIZ_graph_LIBRARY NAMES graph )
FIND_LIBRARY(GRAPHVIZ_cgraph_LIBRARY NAMES cgraph )
FIND_LIBRARY(GRAPHVIZ_cdt_LIBRARY NAMES cdt )
FIND_LIBRARY(GRAPHVIZ_pathplan_LIBRARY NAMES pathplan )

SET(GRAPHVIZ_LIBRARY ${GRAPHVIZ_gvc_LIBRARY} ${GRAPHVIZ_cgraph_LIBRARY} ${GRAPHVIZ_graph_LIBRARY} ${GRAPHVIZ_cdt_LIBRARY} ${GRAPHVIZ_pathplan_LIBRARY})

INCLUDE(FindPackageHandleStandardArgs)
FIND_PACKAGE_HANDLE_STANDARD_ARGS(GRAPHVIZ DEFAULT_MSG GRAPHVIZ_LIBRARY GRAPHVIZ_INCLUDE_DIR)

IF(GRAPHVIZ_FOUND)
    SET(GRAPHVIZ_LIBRARIES ${GRAPHVIZ_LIBRARY})
    SET(GRAPHVIZ_INCLUDE_DIRS ${GRAPHVIZ_INCLUDE_DIR})
ELSE(GRAPHVIZ_FOUND)
    SET(GRAPHVIZ_LIBRARIES)
    SET(GRAPHVIZ_INCLUDE_DIRS)
ENDIF(GRAPHVIZ_FOUND)

MARK_AS_ADVANCED(GRAPHVIZ_INCLUDE_DIRS GRAPHVIZ_LIBRARIES)
