#include "dague.h"
#include "arena.h" /* get rid of this */
#include "data_distribution.h"
#include "data_dist/matrix/two_dim_rectangle_cyclic.h"
#include "touch.h"

#define BLOCK 10
#define N     100

extern int touch_finalize(void);
extern dague_object_t* touch_initialize(int block, int n);

int main( int argc, char** argv )
{
    dague_context_t* dague;
    dague_object_t* object;

#ifdef HAVE_MPI
    MPI_Init(NULL, NULL);
#endif

    (void)argc; (void)argv;
    dague = dague_init(1, NULL, NULL);
    assert( NULL != dague );

    object = touch_initialize(BLOCK, N);

    dague_enqueue( dague, (dague_object_t*)object );

    dague_progress(dague);

#ifdef DAGUE_PROF_TRACE
    char* filename = NULL;
#if defined(HAVE_MPI)
    int rank;
    MPI_Comm_rank(MPI_COMM_WORLD, &rank);
    asprintf(&filename, "%s-%d.profile", __FILE__, rank);
#else
    asprintf(&filename, "%s.profile", __FILE__);
#endif
    dague_profiling_dump_dbp(filename);
    free(filename);
#endif  /* DAGUE_PROF_TRACE */
    dague_fini( &dague);

    touch_finalize();
#ifdef HAVE_MPI
    MPI_Finalize();
#endif
    return 0;
}
